# coding: utf-8

"""
    Insights Service API -test

    ## Introduction to PlotRisk  PlotRisk is a module, which ease to create plot for the given area of interest and also   facilitate to check satellite indices, weather and yield data.    **Note**``  Indices, Weather and Yield data can be accessed based on features subscriptions.  ``  ## Resources  A resource is an entity that has a set of exposed operations. The entity can represent an actual object (account, users..) or a set of logical operations collated together. It is up to the specification user to decide whether sub-resources should be referred to as part of their main resource or as a resource of their own. For example, assume the following URL set:     ```    /users         -GET                   POST                    /users/{id}    -GET                   PATCH                   DELETE   ```  For more details, see [CRUD Operations](https://docs.microsoft.com/en-us/iis-administration/api/crud) to learn more about it.  ## Trying the API  You can use [Swagger UI](https://swagger.io/tools/swagger-ui/) or any third party client such as ,[Postman](https://www.postman.com/), [cURL](https://curl.se/) etc. to test the REST API.    **Swagger UI**    **Step 1.** Generate access tokens using **/token** resource      **Info** : ``If you are a SMARTFARM_PLUS user, you can request for tokens using tenant,username,password  ``    **Step 2.** Copy **_access_token_** from **Step 1**, then click on **Authorize** button and paste the token.    **Step 3.** Select an API resource and click on **_Try it out_**.    **Step 4.** Fill the headers such as _**TenantType**_, _**OrgId**_ & _**X-Api-Key**_.    **Info** : ``X-Api-Key can be obtained from Step 1  ``    **Step 5.**  Query parameters are optional. It filters result based on provided parameter value.  ```   e.g.   {           \"size\": 300,           \"page\": 0,          }             e.g.   {          }            ```   **Step 6.** Click on **Execute**    **Curl**  ```  curl -X 'GET' \\  'http://localhost:8085/api/v1/crops' \\  -H 'accept: application/json' \\  -H 'TenantType: SMARTRISK' \\  -H 'orgId: test' \\  -H 'X-Api-Key: qwjokooopppp' \\  -H 'Authorization: Bearer jklkopalkddlplplllllllllll2340k'  ```  Using a graphical tool such as Postman, it is possible to import the API specifications directly:    - Download the API specification by clicking the **swagger.json** hypelink at top of this document  - Import the JSON specification in the graphical tool of your choice.  - In *Postman*, you can click the import button at the top    ## Authentication  The API authentication process validates the identity of the client attempting to make a connection by using an authentication protocol.  **Access Token** is required to access PlotRisk APIs & same can be generated by following API on passing valid request payload (see Token API)  ```  POST   /tokens  ```    For more details, see [Authentication and Authorization](https://swagger.io/docs/specification/authentication/).    ## Errors  The REST API reports errors by returning an appropriate HTTP response code, for example 404 (Not Found), and a JSON response. Any HTTP response code that is not in the range 200 - 299 is considered an error.    For more details on HTTP Status code, see [HTTP Status Codes](https://restfulapi.net/http-status-codes/)   # noqa: E501

    OpenAPI spec version: v1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Metrics(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'error_codes': 'dict(str, object)',
        'boundary_metrics': 'BoundaryMetrics',
        'crop_metrics': 'list[CropMetric]'
    }

    attribute_map = {
        'error_codes': 'errorCodes',
        'boundary_metrics': 'boundaryMetrics',
        'crop_metrics': 'cropMetrics'
    }

    def __init__(self, error_codes=None, boundary_metrics=None, crop_metrics=None):  # noqa: E501
        """Metrics - a model defined in Swagger"""  # noqa: E501
        self._error_codes = None
        self._boundary_metrics = None
        self._crop_metrics = None
        self.discriminator = None
        if error_codes is not None:
            self.error_codes = error_codes
        if boundary_metrics is not None:
            self.boundary_metrics = boundary_metrics
        if crop_metrics is not None:
            self.crop_metrics = crop_metrics

    @property
    def error_codes(self):
        """Gets the error_codes of this Metrics.  # noqa: E501


        :return: The error_codes of this Metrics.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._error_codes

    @error_codes.setter
    def error_codes(self, error_codes):
        """Sets the error_codes of this Metrics.


        :param error_codes: The error_codes of this Metrics.  # noqa: E501
        :type: dict(str, object)
        """

        self._error_codes = error_codes

    @property
    def boundary_metrics(self):
        """Gets the boundary_metrics of this Metrics.  # noqa: E501


        :return: The boundary_metrics of this Metrics.  # noqa: E501
        :rtype: BoundaryMetrics
        """
        return self._boundary_metrics

    @boundary_metrics.setter
    def boundary_metrics(self, boundary_metrics):
        """Sets the boundary_metrics of this Metrics.


        :param boundary_metrics: The boundary_metrics of this Metrics.  # noqa: E501
        :type: BoundaryMetrics
        """

        self._boundary_metrics = boundary_metrics

    @property
    def crop_metrics(self):
        """Gets the crop_metrics of this Metrics.  # noqa: E501


        :return: The crop_metrics of this Metrics.  # noqa: E501
        :rtype: list[CropMetric]
        """
        return self._crop_metrics

    @crop_metrics.setter
    def crop_metrics(self, crop_metrics):
        """Sets the crop_metrics of this Metrics.


        :param crop_metrics: The crop_metrics of this Metrics.  # noqa: E501
        :type: list[CropMetric]
        """

        self._crop_metrics = crop_metrics

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Metrics, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Metrics):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
