# coding: utf-8

"""
    Insights Service API -test

    ## Introduction to PlotRisk  PlotRisk is a module, which ease to create plot for the given area of interest and also   facilitate to check satellite indices, weather and yield data.    **Note**``  Indices, Weather and Yield data can be accessed based on features subscriptions.  ``  ## Resources  A resource is an entity that has a set of exposed operations. The entity can represent an actual object (account, users..) or a set of logical operations collated together. It is up to the specification user to decide whether sub-resources should be referred to as part of their main resource or as a resource of their own. For example, assume the following URL set:     ```    /users         -GET                   POST                    /users/{id}    -GET                   PATCH                   DELETE   ```  For more details, see [CRUD Operations](https://docs.microsoft.com/en-us/iis-administration/api/crud) to learn more about it.  ## Trying the API  You can use [Swagger UI](https://swagger.io/tools/swagger-ui/) or any third party client such as ,[Postman](https://www.postman.com/), [cURL](https://curl.se/) etc. to test the REST API.    **Swagger UI**    **Step 1.** Generate access tokens using **/token** resource      **Info** : ``If you are a SMARTFARM_PLUS user, you can request for tokens using tenant,username,password  ``    **Step 2.** Copy **_access_token_** from **Step 1**, then click on **Authorize** button and paste the token.    **Step 3.** Select an API resource and click on **_Try it out_**.    **Step 4.** Fill the headers such as _**TenantType**_, _**OrgId**_ & _**X-Api-Key**_.    **Info** : ``X-Api-Key can be obtained from Step 1  ``    **Step 5.**  Query parameters are optional. It filters result based on provided parameter value.  ```   e.g.   {           \"size\": 300,           \"page\": 0,          }             e.g.   {          }            ```   **Step 6.** Click on **Execute**    **Curl**  ```  curl -X 'GET' \\  'http://localhost:8085/api/v1/crops' \\  -H 'accept: application/json' \\  -H 'TenantType: SMARTRISK' \\  -H 'orgId: test' \\  -H 'X-Api-Key: qwjokooopppp' \\  -H 'Authorization: Bearer jklkopalkddlplplllllllllll2340k'  ```  Using a graphical tool such as Postman, it is possible to import the API specifications directly:    - Download the API specification by clicking the **swagger.json** hypelink at top of this document  - Import the JSON specification in the graphical tool of your choice.  - In *Postman*, you can click the import button at the top    ## Authentication  The API authentication process validates the identity of the client attempting to make a connection by using an authentication protocol.  **Access Token** is required to access PlotRisk APIs & same can be generated by following API on passing valid request payload (see Token API)  ```  POST   /tokens  ```    For more details, see [Authentication and Authorization](https://swagger.io/docs/specification/authentication/).    ## Errors  The REST API reports errors by returning an appropriate HTTP response code, for example 404 (Not Found), and a JSON response. Any HTTP response code that is not in the range 200 - 299 is considered an error.    For more details on HTTP Status code, see [HTTP Status Codes](https://restfulapi.net/http-status-codes/)   # noqa: E501

    OpenAPI spec version: v1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Weather(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'precipitation': 'float',
        'day_temperature': 'float',
        'night_temperature': 'float',
        'day_rh': 'float',
        'night_rh': 'float',
        'mean_temperature': 'float',
        'wind_speed': 'float',
        'gdd': 'float',
        'diurnal_temperature': 'float'
    }

    attribute_map = {
        'precipitation': 'precipitation',
        'day_temperature': 'dayTemperature',
        'night_temperature': 'nightTemperature',
        'day_rh': 'dayRH',
        'night_rh': 'nightRH',
        'mean_temperature': 'meanTemperature',
        'wind_speed': 'windSpeed',
        'gdd': 'gdd',
        'diurnal_temperature': 'diurnalTemperature'
    }

    def __init__(self, precipitation=None, day_temperature=None, night_temperature=None, day_rh=None, night_rh=None, mean_temperature=None, wind_speed=None, gdd=None, diurnal_temperature=None):  # noqa: E501
        """Weather - a model defined in Swagger"""  # noqa: E501
        self._precipitation = None
        self._day_temperature = None
        self._night_temperature = None
        self._day_rh = None
        self._night_rh = None
        self._mean_temperature = None
        self._wind_speed = None
        self._gdd = None
        self._diurnal_temperature = None
        self.discriminator = None
        if precipitation is not None:
            self.precipitation = precipitation
        if day_temperature is not None:
            self.day_temperature = day_temperature
        if night_temperature is not None:
            self.night_temperature = night_temperature
        if day_rh is not None:
            self.day_rh = day_rh
        if night_rh is not None:
            self.night_rh = night_rh
        if mean_temperature is not None:
            self.mean_temperature = mean_temperature
        if wind_speed is not None:
            self.wind_speed = wind_speed
        if gdd is not None:
            self.gdd = gdd
        if diurnal_temperature is not None:
            self.diurnal_temperature = diurnal_temperature

    @property
    def precipitation(self):
        """Gets the precipitation of this Weather.  # noqa: E501


        :return: The precipitation of this Weather.  # noqa: E501
        :rtype: float
        """
        return self._precipitation

    @precipitation.setter
    def precipitation(self, precipitation):
        """Sets the precipitation of this Weather.


        :param precipitation: The precipitation of this Weather.  # noqa: E501
        :type: float
        """

        self._precipitation = precipitation

    @property
    def day_temperature(self):
        """Gets the day_temperature of this Weather.  # noqa: E501


        :return: The day_temperature of this Weather.  # noqa: E501
        :rtype: float
        """
        return self._day_temperature

    @day_temperature.setter
    def day_temperature(self, day_temperature):
        """Sets the day_temperature of this Weather.


        :param day_temperature: The day_temperature of this Weather.  # noqa: E501
        :type: float
        """

        self._day_temperature = day_temperature

    @property
    def night_temperature(self):
        """Gets the night_temperature of this Weather.  # noqa: E501


        :return: The night_temperature of this Weather.  # noqa: E501
        :rtype: float
        """
        return self._night_temperature

    @night_temperature.setter
    def night_temperature(self, night_temperature):
        """Sets the night_temperature of this Weather.


        :param night_temperature: The night_temperature of this Weather.  # noqa: E501
        :type: float
        """

        self._night_temperature = night_temperature

    @property
    def day_rh(self):
        """Gets the day_rh of this Weather.  # noqa: E501


        :return: The day_rh of this Weather.  # noqa: E501
        :rtype: float
        """
        return self._day_rh

    @day_rh.setter
    def day_rh(self, day_rh):
        """Sets the day_rh of this Weather.


        :param day_rh: The day_rh of this Weather.  # noqa: E501
        :type: float
        """

        self._day_rh = day_rh

    @property
    def night_rh(self):
        """Gets the night_rh of this Weather.  # noqa: E501


        :return: The night_rh of this Weather.  # noqa: E501
        :rtype: float
        """
        return self._night_rh

    @night_rh.setter
    def night_rh(self, night_rh):
        """Sets the night_rh of this Weather.


        :param night_rh: The night_rh of this Weather.  # noqa: E501
        :type: float
        """

        self._night_rh = night_rh

    @property
    def mean_temperature(self):
        """Gets the mean_temperature of this Weather.  # noqa: E501


        :return: The mean_temperature of this Weather.  # noqa: E501
        :rtype: float
        """
        return self._mean_temperature

    @mean_temperature.setter
    def mean_temperature(self, mean_temperature):
        """Sets the mean_temperature of this Weather.


        :param mean_temperature: The mean_temperature of this Weather.  # noqa: E501
        :type: float
        """

        self._mean_temperature = mean_temperature

    @property
    def wind_speed(self):
        """Gets the wind_speed of this Weather.  # noqa: E501


        :return: The wind_speed of this Weather.  # noqa: E501
        :rtype: float
        """
        return self._wind_speed

    @wind_speed.setter
    def wind_speed(self, wind_speed):
        """Sets the wind_speed of this Weather.


        :param wind_speed: The wind_speed of this Weather.  # noqa: E501
        :type: float
        """

        self._wind_speed = wind_speed

    @property
    def gdd(self):
        """Gets the gdd of this Weather.  # noqa: E501


        :return: The gdd of this Weather.  # noqa: E501
        :rtype: float
        """
        return self._gdd

    @gdd.setter
    def gdd(self, gdd):
        """Sets the gdd of this Weather.


        :param gdd: The gdd of this Weather.  # noqa: E501
        :type: float
        """

        self._gdd = gdd

    @property
    def diurnal_temperature(self):
        """Gets the diurnal_temperature of this Weather.  # noqa: E501


        :return: The diurnal_temperature of this Weather.  # noqa: E501
        :rtype: float
        """
        return self._diurnal_temperature

    @diurnal_temperature.setter
    def diurnal_temperature(self, diurnal_temperature):
        """Sets the diurnal_temperature of this Weather.


        :param diurnal_temperature: The diurnal_temperature of this Weather.  # noqa: E501
        :type: float
        """

        self._diurnal_temperature = diurnal_temperature

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Weather, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Weather):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
